#!/bin/sh

inbl()
{
   FILENAME=$1
   FOUND=0
   for funcs in `nm $FILENAME | grep ' [TD] ' | awk '{print $3}'`
   do
     if test "x`grep $funcs BLASLIST`" != "x"; then
        echo "BLASFUNC $funcs $FILENAME"
        FOUND=1
     else
        if test "x`grep $funcs LAPACKLIST`" != "x"; then
           echo "LAPACKFUNC $funcs $FILENAME"
           FOUND=1
        else
            nm=$funcs
            while test "x$nm" != "x"
            do
               nm=`echo $nm|sed -e 's/.$//'`
               if test "x`grep "^$nm$" BLASLIST`" != "x"; then
                 echo "Blasfunc $funcs $FILENAME $nm"
                 nm=""
                 FOUND=1
               else
                 if test "x`grep "^$nm$" LAPACKLIST`" != "x"; then
                   echo "Lapackfunc $funcs $FILENAME $nm"
                   nm=""
                   FOUND=1
                 fi
               fi
            done
        fi
        if test "`echo $funcs | sed -e 's/^blas_.*$/blas_/'`" == "blas_" ;then
                   echo "BLASFUNC $funcs $FILENAME $nm"
		   FOUND=1
        fi
        if test "`echo $funcs | sed -e 's/^cblas_.*$/cblas_/'`" == "cblas_" ;then
                   echo "BLASFUNC $funcs $FILENAME $nm"
		   FOUND=1
        fi
        for fcnm in `cat BLASLIST|sed -e 's/_$//'`
        do
            if test $FOUND == 0; then
                tmpnm=`echo $funcs| sed -e "s/^$fcnm//"`
                if test "x$tmpnm" != "$funcs"; then
                   echo "BLASFUNC $funcs $FILENAME $tmpnm"
		   FOUND=1
                fi
            fi
        done
        for fcnm in `cat LAPACKLIST|sed -e 's/_$//'`
        do
            if test $FOUND == 0; then
                tmp = `echo $funcs| sed -e "s/^$fcnm//"`
                if test "x$tmp" != "$funcs"; then
                   echo "BLASFUNC $funcs $FILENAME $nm"
		   FOUND=1
                fi
            fi
        done
        if test $FOUND == 0; then
            echo "OTHERFUNC $funcs $FILENAME"
        fi
     fi
   done 
}

(
  for i in `find kernel -name '*.o'`
  do
     inbl $i
  done
  for i in `find driver -name '*.o'`
  do
     inbl $i
  done
  for i in `find interface -name '*.o'`
  do
     inbl $i
  done
  for i in `find lapack -name '*.o'`
  do
     inbl $i
  done
  for i in `find lapack-3.1.1 -name '*.o'`
  do
     inbl $i
  done
) | sort |uniq > TMP

awk '/^L/{print $3}' TMP |sort|uniq > lapackobj
awk '/^B/{print $3}' TMP |sort|uniq > blasobj

rm -f TMP
